//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Constants.h
//**       Project:  Quick Start Project
//**       Created:  25 Jun 2002 by Ryan Northcott
//**       Revised:  08 Sep 2006 by Dan Beutel
//**
//**   Description:  Contains definitions for constants used by your XInc2 Application.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

// Memory
#define	kStackSize			128

// Hardware Semaphore Assignments
#define	kADC_Semaphore		kHardwareSemaphore0
#define	kSPI0CS_Semaphore		kHardwareSemaphore1
#define	kDevLEDs_Semaphore	kHardwareSemaphore2



#define	_PWM_Period			100	//PWM period is 100 ticks of TimerA clock
#define	_PWM_Init			0	//Lets start the PWM signals at 0% duty cycle

#define	_SN_devider			9	//Proportionanly constant to get result in mm 
#define	_SN_min			100	//Below this the result will be 0
#define	_SN_max			400	//Above this the result will be 0xFFFF
#define	_SN_trigger			10	//Length of the trigger pulse in instruction times
#define	_SN_attempts		4	//Number of errors before returning (no response from sonar)
#define	_SN_time			32000 //Returns after this many instruction times after
							//the rising edge of the sonar signal is detected
							
#define	_TurnRadius			1000	//Robot turning radius = _TurnRadius/100

#define     _Turn_DF			20