//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Long Data.asm
//**       Project:  Quick Start Project
//**       Created:  25 Jun 2002 by Ryan Northcott
//**       Revised:  08 Sep 2006 by Dan Beutel
//**
//**   Description:  Contains the data (memory variables and tables) used by your XInC2 Application.
//**                 All data should be stored in this file or in the "Short Data.asm" file to
//**                 ensure that it is stored in a separate 2kWord memory block from all code.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//--------------------------------------------------
// Allocate space for each thread's call stack

#ifdef __DEBUGGER__
T0_SP:	@ = @ + kStackSize
#endif

#ifdef __TP__
T0_SP:	@ = @ + kStackSize
#endif

#ifdef __T0__
T0_SP:	@ = @ + kStackSize
#endif

#ifdef __TP__
T1_SP:	@ = @ + kStackSize
#endif

#ifdef __P1__
T1_SP:	@ = @ + kStackSize
#endif

#ifdef __T1__
T1_SP:	@ = @ + kStackSize
#endif

#ifdef __TP__
T2_SP:	@ = @ + kStackSize
#endif

#ifdef __T2__
T2_SP:	@ = @ + kStackSize
#endif

#ifdef __T3__
T3_SP:	@ = @ + kStackSize
#endif

#ifdef __T4__
T4_SP:	@ = @ + kStackSize
#endif

#ifdef __T5__
T5_SP:	@ = @ + kStackSize
#endif

#ifdef __T6__
T6_SP:	@ = @ + kStackSize
#endif

#ifdef __T7__
T7_SP:	@ = @ + kStackSize
#endif

//--------------------------------------------------
// Define your data here

PWMdata0:			0			//Duty cycle of PWM signal for motor 0
PWMdata1:			0			//Duty cycle of PWM signal for motor 1

Dir0:				1			//Direction for motor 0, 1=Forward, 0=reverse
Dir1:                   1			//Direction for motor 1, 1=Forward, 0=reverse

DEFdata:			0			//First 4 are LD last 4 are Bumpers
SNdata:			0xFFFF		//Sonar Data

IRdata0:			0x03FF		//Left IR sensor data 
IRdata1:			0x03FF		//Right IR sensor data

ECdata0:			0			//Wheel encoder count for motor0
ECdata1:			0			//Wheel encoder count for motor1
ECstate:			0

ECdata0a:			0	
ECdata1a:			0

ECdata0c:			0	
ECdata1c:			0

CSdata0:			0			//Current Sensors data for motor0
CSdata1:			0			//Current Sensors data for motor1

DRIVEcfg0:			0			//Distance and Speed for Drive
DRIVEcfg1:			0			//DEFdata, Direction and Degrees for Drive
DRIVEdata:			0	

SENcfg0:			0	
SENdata0:			0
SENcfg1:			0
SENdata1:			0
SENcfg2:			0
SENdata2:			0

DRIVE_EN:			0
SST_EN:			0
Check_data:			0

PWMdata0a:			0			//State of PWM before Drive routine exits
PWMdata1a:			0			//State of PWM before Drive routine exits

IRdata0a:			0x03FF
IRdata1a:			0x03FF

IRdata0b:			0x03FF
IRdata1b:			0x03FF

CSdata0a:			0
CSdata1a:			0

CSdata0b:			0
CSdata1b:			0

ECdata0b:			0	
ECdata1b:			0

ECtime0:			0	//Vel in cm/s
ECtime1:			0

ECtime0b:			0	//Max Vel
ECtime1b:			0

ECtime0a:			0	//Raw velocity data
ECtime1a:			0

LEDdata:			0
SNdata1:			0xFFFF		//Sonar Data