//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Attack_P1.asm
//**       Project:  Mini Sumo Project
//**       Created:  7 Mar 2009 by Josh Sparrow
//**       Revised:  7 Mar 2009 by Josh Sparrow
//**
//**   Description:  Used by Program1 to run offense.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Attack_P1
//	This routine is used operate the robot in an
//	offensive maner.

Attack_P1:
		
	// Store registers on stack
	st	r0, sp, 0		//Junk
	st	r1, sp, 1		//Junk
	st	r2, sp, 2		//Direction
	st	r3, sp, 3		//Turn Radius
	st	r4, sp, 4		//Turn Angle
	st	r6, sp, 5
	add	sp, sp, 6

Start_AT:
	//Check semsors
	mov	r0,0x0FF1
	st	r0,SENcfg0
	
	mov	r0,0x000F
	st	r0,SENcfg1
	
	jsr	r6,SENcheck
	
	//Check Defensive sensors
	ld	r0,SENdata0
	and	r0,r0,0x0FF0
	bc	ZC,End_AT	
	
	//Determine state
	ld	r0,SENdata1
	add	r1,r0,-3
	bc	ZS,S6_AT

	add	r1,r0,-15
	bc	ZS,S5_AT

	add	r1,r0,-9
	bc	ZS,S4_AT

	add	r1,r0,-11
	bc	ZS,S3_AT

	add	r1,r0,-7
	bc	ZS,S2_AT

	add	r1,r0,-5
	bc	ZS,S1_AT
	
S6_AT:
	mov	r0,0x0002		//Check if SN is cleared
	st	r0,SENcfg1

	mov	r0,0x000D		//Check if IR0 or IR1 are set
	st	r0,SENcfg2

	mov	r2,1			//Set direction to 1
	mov	r3,0			//Set radius to 0
	mov	r4,0			//Set turn angle to 0

	jsr	r6,Set_Drive_AT
	bra	Start_AT

S5_AT:
	mov	r0,0x000C		//Check if IR0 or IR1 are cleared
	st	r0,SENcfg1

	mov	r0,0x0003		//Check if SN is set
	st	r0,SENcfg2

	mov	r2,1			//Set direction to 1
	mov	r3,0			//Set radius to 0
	mov	r4,0			//Set turn angle to 0

	jsr	r6,Set_Drive_AT
	bra	Start_AT

S4_AT:
	mov	r0,3
	st	r0,HUdata
	bra	End_AT

S3_AT:
	mov	r0,0x000A		//Check if SN or IR1 are cleared
	st	r0,SENcfg1
	
	mov	r0,0x0005		//Check if IR0 is set
	st	r0,SENcfg2

	jsr	r6,Set_Dir_AT
	
	mov	r2,3			//Set direction to 3
	jsr	r6,Set_Drive_AT
	bra	Start_AT

S2_AT:
	mov	r0,0x0006		//Check if SN or IR0 are cleared
	st	r0,SENcfg1
	
	mov	r0,0x0009		//Check if IR1 is set
	st	r0,SENcfg2

	jsr	r6,Set_Dir_AT
	
	mov	r2,2			//Set direction to 2
	jsr	r6,Set_Drive_AT
	bra	Start_AT

S1_AT:
	mov	r0,2
	st	r0,HUdata
	
End_AT:				//Need to hunt or defend

	//Restore registers
	sub	sp, sp, 6
	ld	r6, sp, 5
	ld	r4, sp, 4		
	ld	r3, sp, 3
	ld	r2, sp, 2		
	ld	r1, sp, 1
	ld	r0, sp, 0


//=======================================================
//	Set_Drive_AT
//	This routine is used set the Drive registers
//	according to r2, r3, r4.

Set_Drive_AT:

	// Store registers on stack
	st	r0, sp, 0		//Junk
	st	r1, sp, 1		//Junk
	st	r6, sp, 2
	add	sp, sp, 3

	mov	r0,100		//Set speed to 100%
	rol	r1,r3,8
	add	r0,r0,r1
	st	r0,DRIVEcfg0


	rol	r0,r2,13		//Adjust direction register
	add	r0,r0,r4
	st	r0,DRIVEcfg1
	jsr	r6,Drive

	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Set_Dir_AT
//	This routine is used set the direction of
//	travel. This sets r3 and r4 for Set_Drive_AT.

Set_Dir_AT:

	// Store registers on stack
	st	r6, sp, 0
	add	sp, sp, 1

	//Can set turn path using velocity
	//of opponent.
	ld	r3,SNdata	//Set turn radius
	mov	r4,20		//Set turn angle

	//Restore registers
	sub	sp, sp, 1
	ld	r6, sp, 0
	
	jsr	r6, r6