//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Defense_P1.asm
//**       Project:  Mini Sumo Project
//**       Created:  7 Mar 2009 by Josh Sparrow
//**       Revised:  7 Mar 2009 by Josh Sparrow
//**
//**   Description:  Used by Program1 to run defense.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Defense_P1.asm
//	This routine is used operate the robot in a
//	defensive maner.

Defense_P1:
		
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2		//Direction
	st	r3, sp, 3		//Turn Radius
	st	r4, sp, 4		//Turn Angle
	st	r6, sp, 5
	add	sp, sp, 6

Start_DF:
	//Check semsors
	mov	r0,0x0FF1
	st	r0,SENcfg0

	mov	r0,0
	st	r0,SENcfg1
	mov	r0,0
	st	r0,SENcfg2

	jsr	r6,SENcheck

	//Determine state
	mov	r0,0
	st	r0,SENcfg0
	ld	r0,SENdata0

	and	r1,r0,0x0FF0
	bc	ZS,End_DF

	add	r1,r0,-0x0101
	bc	ZS,S1_DF

	add	r1,r0,-0x0201
	bc	ZS,S2_DF

	add	r1,r0,-0x0401
	bc	ZS,S3_DF

	add	r1,r0,-0x0801
	bc	ZS,S4_DF

	add	r1,r0,-0x0301
	bc	ZS,S5_DF

	add	r1,r0,-0x0A01
	bc	ZS,S6_DF

	add	r1,r0,-0x0C01
	bc	ZS,S7_DF

	add	r1,r0,-0x0501
	bc	ZS,S8_DF

	add	r1,r0,-0x0011
	bc	ZS,S9_DF

	add	r1,r0,-0x0021
	bc	ZS,S10_DF

	add	r1,r0,-0x0041
	bc	ZS,S11_DF

	add	r1,r0,-0x0081
	bc	ZS,S12_DF

	add	r1,r0,-0x0111
	bc	ZS,S13_DF

	add	r1,r0,-0x0211
	bc	ZS,S14_DF

	add	r1,r0,-0x0411
	bc	ZS,S15_DF

	add	r1,r0,-0x0811
	bc	ZS,S16_DF

	add	r1,r0,-0x0311
	bc	ZS,S17_DF

	add	r1,r0,-0x0A11
	bc	ZS,S18_DF

	add	r1,r0,-0x0C11
	bc	ZS,S19_DF

	add	r1,r0,-0x0511
	bc	ZS,S20_DF

	add	r1,r0,-0x0121
	bc	ZS,S21_DF

	add	r1,r0,-0x0221
	bc	ZS,S22_DF

	add	r1,r0,-0x0421
	bc	ZS,S23_DF

	add	r1,r0,-0x0821
	bc	ZS,S24_DF

	add	r1,r0,-0x0321
	bc	ZS,S25_DF

	add	r1,r0,-0x0A21
	bc	ZS,S26_DF

	add	r1,r0,-0x0C21
	bc	ZS,S27_DF

	add	r1,r0,-0x0521
	bc	ZS,S28_DF

	add	r1,r0,-0x0141
	bc	ZS,S29_DF

	add	r1,r0,-0x0241
	bc	ZS,S30_DF

	add	r1,r0,-0x0441
	bc	ZS,S31_DF

	add	r1,r0,-0x0841
	bc	ZS,S32_DF

	add	r1,r0,-0x0341
	bc	ZS,S33_DF

	add	r1,r0,-0x0A41
	bc	ZS,S34_DF

	add	r1,r0,-0x0C41
	bc	ZS,S35_DF

	add	r1,r0,-0x0541
	bc	ZS,S36_DF

	add	r1,r0,-0x0181
	bc	ZS,S37_DF

	add	r1,r0,-0x0281
	bc	ZS,S38_DF

	add	r1,r0,-0x0481
	bc	ZS,S39_DF

	add	r1,r0,-0x0881
	bc	ZS,S40_DF

	add	r1,r0,-0x0381
	bc	ZS,S41_DF

	add	r1,r0,-0x0A81
	bc	ZS,S42_DF

	add	r1,r0,-0x0C81
	bc	ZS,S43_DF

	add	r1,r0,-0x0581
	bc	ZS,S44_DF
	
	bra	Start_DF

S1_DF:
	//Move back 5cm then spin right 135.
	mov	r2,0
	mov	r3,0
	mov	r4,5
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,135
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S2_DF:
	//Move back 5cm then spin left 135.
	mov	r2,0
	mov	r3,0
	mov	r4,5
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,135
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S3_DF:
	//Move forward 5cm then spin right 45.
	mov	r2,1
	mov	r3,0
	mov	r4,5
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,45
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S4_DF:
	//Move forward 5cm then spin left 45.
	mov	r2,1
	mov	r3,0
	mov	r4,5
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,45
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S5_DF:
	//Move back 5cm then spin right 180.
	mov	r2,0
	mov	r3,0
	mov	r4,5
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,180
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S6_DF:
	//Pivot left 90.
	mov	r2,2
	mov	r3,90
	mov	r4,5
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S7_DF:
	//Move forward 5cm.
	mov	r2,1
	mov	r3,0
	mov	r4,5
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S8_DF:
	//Pivot right 90.
	mov	r2,3
	mov	r3,90
	mov	r4,5
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S9_DF:
	//Move forward.
	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,1
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S10_DF:
	//Move forward 20cm, spin right 90, trun right 20cm 90, spin right 90.
	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,1
	mov	r3,0
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S11_DF:
	//Move forward 20cm, spin left 90, trun left 20cm 90, spin left 90.
	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,1
	mov	r3,0
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S12_DF:
	//Move backward.
	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,0
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S13_DF:
	//Turn left 20cm 180
	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S14_DF:
	//Turn right 20cm 180
	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S15_DF:
	//Move forward.
	mov	r0,0x0400
	st	r0,SENcfg0

	mov	r2,1
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S16_DF:
	//Move forward.
	mov	r0,0x0800
	st	r0,SENcfg0

	mov	r2,1
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S17_DF:
	//Move backward 10cm.
	mov	r2,0
	mov	r3,0
	mov	r4,10
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S18_DF:
	//Turn right 20cm 180
	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S19_DF:
	//Move forward.
	mov	r0,0x0C00
	st	r0,SENcfg0
	
	mov	r2,1
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S20_DF:
	//Turn left 20cm 180
	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S21_DF:
	//Turn backright 20cm 180, spin right 90, turn left 20cm 90
	mov	r2,5
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S22_DF:
	//Turn backleft 20cm 90, spin left 90, turn right 20cm 90
	mov	r2,4
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S23_DF:
	//Turn right 20cm 180, spin right 90, turn right 20cm 180
	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S24_DF:
	//Turn left 20cm 90, spin left 90, turn left 20cm 90
	mov	r2,2
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S25_DF:
	//Turn backright 20cm 180, spin right 90
	mov	r2,5
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S26_DF:
	//Turn left 20cm 180, spin left 90
	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S27_DF:
	//Turn left 20cm 180, spin left 90
	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S28_DF:
	//Turn right 20cm 180, spin right 90
	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S29_DF:
	//Turn backright 20cm 90, spin right 90, turn left 20cm 90
	mov	r2,5
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S30_DF:
	//Turn backleft 20cm 180, spin left 90, turn right 20cm 90
	mov	r2,4
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S31_DF:
	//Turn right 20cm 90, spin right 90, turn right 20cm 90
	mov	r2,3
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,3
	mov	r3,90
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF
	
S32_DF:
	//Turn left 20cm 180, spin left 90, turn left 20cm 180
	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF
	
S33_DF:
	//Turn backleft 20cm 180, spin left 90
	mov	r2,4
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF
	
S34_DF:
	//Turn left 20cm 180, spin left 90
	mov	r2,2
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,2
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF
	
S35_DF:
	//Turn right 20cm 180, spin right 90
	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF
	
S36_DF:
	//Turn right 20cm 180, spin right 90
	mov	r2,3
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	mov	r0,0x0F01
	st	r0,SENcfg0

	mov	r2,3
	mov	r3,90
	mov	r4,0
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S37_DF:
	//Move backward.
	mov	r0,0x0100
	st	r0,SENcfg0

	mov	r2,0
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S38_DF:
	//Move backward.
	mov	r0,0x0200
	st	r0,SENcfg0

	mov	r2,0
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S39_DF:
	//Turn backleft 20cm 180
	mov	r2,4
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S40_DF:
	//Turn backright 20cm 180
	mov	r2,5
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S41_DF:
	//Move backward.
	mov	r0,0x0300
	st	r0,SENcfg0

	mov	r2,0
	mov	r3,0
	mov	r4,100
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S42_DF:
	//Turn backright 20cm 180
	mov	r2,5
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S43_DF:
	//Move forward 10cm.
	mov	r2,1
	mov	r3,0
	mov	r4,10
	jsr	r6,Set_Drive_DF

	bra	Start_DF

S44_DF:
	//Turn backleft 20cm 180
	mov	r2,4
	mov	r3,180
	mov	r4,_Turn_DF
	jsr	r6,Set_Drive_DF

	bra	Start_DF
	
End_DF:
	//Restore registers
	sub	sp, sp, 6
	ld	r6, sp, 5
	ld	r4, sp, 4
	ld	r3, sp, 3
	ld	r2, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Set_Drive_DF
//	This routine is used set the Drive registers
//	according to r2, r3, r4.

Set_Drive_DF:

	// Store registers on stack
	st	r0, sp, 0		//Junk
	st	r1, sp, 1		//Junk
	st	r6, sp, 2
	add	sp, sp, 3

	mov	r0,100		//Set speed to 100%
	rol	r1,r3,8
	add	r0,r0,r1
	st	r0,DRIVEcfg0


	rol	r0,r2,13		//Adjust direction register
	add	r0,r0,r4
	st	r0,DRIVEcfg1
	jsr	r6,Drive

	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6