//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Check_Sensors.asm
//**       Project:  Mini Sumo Project
//**       Created:  20 Feb 2009 by Josh Sparrow
//**       Revised:  20 Feb 2009 by Josh Sparrow
//**
//**   Description:  This routine is used by the Test Program to display the sensor status to
//**			   a terminal.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Display_Sensors
//	This routine is used by the test program to
//	display the status of all offensive and
//	defensive sensors.

Display_Sensors:
	// Store registers on stack
	st	r1, sp, 0
	st	r6, sp, 1
	add	sp, sp, 2

Start_DS:
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_DS0
	jsr	r6, XPD_EchoString
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	

	
	mov	r1, STRING_SN
	jsr	r6, XPD_EchoString
	ld	r1, SNdata
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_AN0
	jsr	r6, XPD_EchoString
	ld	r1, IRdata0
	jsr	r6, XPD_EchoUnsignedDecNLZ	
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_AN1
	jsr	r6, XPD_EchoString
	ld	r1, IRdata1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_BP0
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	
	
	mov	r1, STRING_BP1
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-1
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_BP2
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-2
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_BP3
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-3
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_LD0
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-4
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	
	
	mov	r1, STRING_LD1
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-5
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_LD2
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-6
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_LD3
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-7
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_DS1
	jsr	r6, XPD_EchoString
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1,0
	jsr	r6, XPD_ReadByte


	//Restore registers
	sub	sp, sp, 2
	ld	r6, sp, 1
	ld	r1, sp, 0
	
	jsr	r6, r6