//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  IRConv.asm
//**       Project:  Mini Sumo Project
//**       Created:  12 Jan 2009 by Josh Sparrow
//**       Revised:  12 Feb 2009 by Josh Sparrow
//**
//**   Description:  This file contains the application code that will be operate the sonar.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	IR_Conv
//	This routine is used to operate the IR sensors. The
//	distance to an object in mm is placed in SNdata.

IR_Conv:
	
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r6, sp, 3
	add	sp, sp, 4
IR0check:

	ld 	r0, IRdata0b
	and	r0,r0,0x03FF
	add	r1,r0, -90
	bc	NS,AN_IR0Readmore30
	add	r1,r0, -180
	bc	NS,AN_IR0Readmore20
	add	r1,r0, -440
	bc	NS,AN_IR0Readmore10
	add	r1,r0, -950
	bc	NS,AN_IR0Readmore4
	add	r1,r0, -950
	bc	ZS,AN_IR0Readmore4
	add	r1,r0,-950
	bc	NC,AN_IR0Readless4
		
AN_IR0Readless4:
	mov r1, 0
	st r1, IRdata0
	bra IR1check

AN_IR0Readmore4:
	
	mov r1, 1290
	sub r1, r1, r0
	mov r2, 85
	jsr r6, UnsignedDivide
	st r1, IRdata0
	bra IR1check
	
AN_IR0Readmore10:
	
	mov r1, 700
	sub r1, r1, r0
	mov r2, 26
	jsr r6, UnsignedDivide
	st r1, IRdata0
	bra IR1check
	
AN_IR0Readmore20:
	
	mov r1, 380
	sub r1, r1, r0
	mov r2, 10
	jsr r6, UnsignedDivide
	st r1, IRdata0
	bra IR1check
	
AN_IR0Readmore30:
	mov r1, 0x03FF
	st r1, IRdata0
	bra IR1check
	
IR1check:	

	ld 	r0, IRdata1b
	and	r0,r0,0x03FF
	add	r1,r0, -90
	bc	NS,AN_IR1Readmore30
	add	r1,r0, -180
	bc	NS,AN_IR1Readmore20
	add	r1,r0, -440
	bc	NS,AN_IR1Readmore10
	add	r1,r0, -950
	bc	NS,AN_IR1Readmore4
	add	r1,r0, -950
	bc	ZS,AN_IR1Readmore4
	add	r1,r0,-950
	bc	NC,AN_IR1Readless4
	
AN_IR1Readless4:
	mov r1, 0x0
	st r1, IRdata1
	bra AN_IREnd

AN_IR1Readmore4:
	
	mov r1, 1290
	sub r1, r1, r0
	mov r2, 85
	jsr r6, UnsignedDivide
	st r1, IRdata1
	bra AN_IREnd
	
AN_IR1Readmore10:
	
	mov r1, 700
	sub r1, r1, r0
	mov r2, 26
	jsr r6, UnsignedDivide
	st r1, IRdata1
	bra AN_IREnd
	
AN_IR1Readmore20:
	
	mov r1, 380
	sub r1, r1, r0
	mov r2, 10
	jsr r6, UnsignedDivide
	st r1, IRdata1
	bra AN_IREnd
	
AN_IR1Readmore30:
	mov r1, 0x03FF
	st r1, IRdata1
	bra AN_IREnd
		
AN_IREnd:
	sub	sp, sp, 4
	ld	r6, sp, 3
	ld	r2, sp, 2		
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6