//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Bumper.asm
//**       Project:  Mini Sumo Project
//**       Created:  22 Jan 2009 by Josh Sparrow
//**       Revised:  12 Feb 2009 by Josh Sparrow
//**
//**   Description:  Routine to update the LEDs.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Update_LED
//	This routine is used to update the LEDs as
//	per the content of LEDdata.

Update_LED:

	//Store registers
	st	r1, sp, 0
	st	r2, sp, 1	
	add	sp, sp, 2

	inp	r1, GPEout
	and	r1,r1,0xFFF0
	ld	r2,LEDdata
	and	r2,r2,0x000F
	add	r1,r1,r2
	outp	r1, GPEout

	//Restore registers
	sub	sp, sp, 2
	ld	r2, sp, 1		
	ld	r1, sp, 0
	
	jsr	r6, r6