//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Thread2.asm
//**       Project:  Quick Start Project
//**       Created:  25 Jun 2002 by Ryan Northcott
//**       Revised:  08 Sep 2006 by Dan Beutel
//**
//**   Description:  This file contains the application code that will be run by thread 2.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

			//This thread demonstrates how to change the Duty cycle of the two PWM signals
			//
Ramp:		
			//set both motors to forward
			mov	r1, 0
			st	r1, Dir0
			st	r1, Dir1
			
			//set PWM to 0% duty cycle for both motors	
	Start_PWM:
			mov	r5, 0	
			st	r5, PWMdata0
			st	r5, PWMdata1

			mov	r1, 0
			st	r1, Dir0
			st	r1, Dir1

			ld	r1, Dir0			
			bix	r1,r1,0
			st	r1, Dir0
			st	r1, Dir1
			
			//Update the motors with direction and speed that we just set above
			jsr	r6, Update_Motors
	      	
			
			
			
			//This next section demonstrates how to change the speed of the motors
			//We will ramp the speed up, hold the speed, then ramp down	
			
			
	RampUpLoop:

			add	r5, r5, 5			//increase the duty cycle by 5 ticks
			sub	r2, r5, _PWM_Period			
			bc	NC, HoldSpeed_a		//When we reach full speed break out of loop
								
			st	r5, PWMdata0		//store the new duty cycle
			st	r5, PWMdata1		
			jsr	r6, Update_Motors		//update the motors
			jsr	r6, DelayReallyLong
			jsr	r6, DelayReallyLong			
			bra RampUpLoop
			
			mov	r5, _PWM_Period
			st	r5, PWMdata0		//store the new duty cycle
			st	r5, PWMdata1
	
	HoldSpeed_a:
		mov	r1, 20	//time to hold the speed for
		
		HoldLoop_a:
//			jsr	r6, DelayReallyLong
//			jsr	r6, DelayReallyLong
//			jsr	r6, DelayReallyLong			
			sub	r1, r1, 1
			bc	ZC, HoldLoop_a
	
	
	
	RampDownLoop:
			sub	r5, r5, 5			//decrease the duty cycle by 5 ticks			
			bc	NS, HoldSpeed_b			//When we reach min speed break out of loop
			
			st	r5, PWMdata0		//store the new duty cycle
			st	r5, PWMdata1		
			jsr	r6, Update_Motors		//update the motors
			
			jsr	r6, DelayReallyLong
			jsr	r6, DelayReallyLong
			bra RampDownLoop
			
			mov	r5, 0
			st	r5, PWMdata0		//store the new duty cycle
			st	r5, PWMdata1
	
	HoldSpeed_b:
		mov	r1, 20	//time to hold the speed for
		
		HoldLoop_b:
//			jsr	r6, DelayReallyLong
//			jsr	r6, DelayReallyLong
//			jsr	r6, DelayReallyLong			
			sub	r1, r1, 1
			bc	ZC, HoldLoop_b
			bra	Start_PWM
		//the motors aren't acctully stopped. You'll have to figure that out. Maybe write a routine
		//that enables/disables the PWM signal for turning the motor on and off.

	bra	@	// Prevent this thread from running away if it is accidentally enabled in the main file