//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Program1.asm
//**       Project:  Mini Sumo Project
//**       Created:  7 Mar 2009 by Josh Sparrow
//**       Revised:  7 Mar 2009 by Josh Sparrow
//**
//**   Description:  Routines to control 2 motors using PWM.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Program1
//	This routine is used operate the robot according
//	to program 1.

Program1:
		
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r6, sp, 3
	add	sp, sp, 4

	jsr	r6,Start_Delay
Hunt:
	jsr	r6,Hunt_P1		//Return if any defensive sensor is activated, or if centred on opponent.

	ld	r0,SENdata0
	and	r0,r0,0x0FF0	//Check Defensive sensors
	bc	ZC,Def0

	jsr	r6,Attack_P1	//Return if any sensor except front bumper is activated

	ld	r0,SENdata0
	and	r0,r0,0x0FF0	//Check Defensive sensors
	bc	ZS,Hunt
	
Def0:
	jsr	r6,Defense_P1
	bra	Hunt
	//Restore registers
	sub	sp, sp, 4
	ld	r6, sp, 3
	ld	r2, sp, 2		
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6