//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Start_Delay.asm
//**       Project:  Mini Sumo Project
//**       Created:  7 Mar 2009 by Josh Sparrow
//**       Revised:  7 Mar 2009 by Josh Sparrow
//**
//**   Description:  Routines to control 2 motors using PWM.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Start_Delay
//	This routine is used to perform a 5sec
//	delay at the beginning of a round.

Start_Delay:
		
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r6, sp, 2
	add	sp, sp, 3
		
	// 5sec is 7.5 million instruction times
	
	mov	r0,7500
	mov	r1,1000
	
Loop_STD0:
Loop_STD1:
	add	r1,r1,-2
	bc	NC,Loop_STD1		

	add	r0,r0,-2
	bc	NC,Loop_STD0

	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6