//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  Test_Program.asm
//**       Project:  Mini Sumo Project
//**       Created:  20 Feb 2009 by Josh Sparrow
//**       Revised:  20 Feb 2009 by Josh Sparrow
//**
//**   Description:  This file contains the application code that will be run the test program.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

//=======================================================
//	Test_Program
//	This routine used to test the robot.


Test_Program:

	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r6, sp, 2
	add	sp, sp, 3
	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_TP0
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
Start_TP:

	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_TP1
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_TP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_TP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_TP4
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_TP6
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

Loop_TP0:
	mov	r1,0
	jsr	r6, XPD_ReadByte

	add	r0,r1,-561
	bc	ZS,DRIVE_TP

	add	r0,r1,-562
	bc	ZS,SEN_TP

	add	r0,r1,-563
	bc	ZS,LED_TP

	add	r0,r1,-564
	bc	ZS,DUMP_TP

	bra	Loop_TP0

DRIVE_TP:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,1
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_TP5
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	jsr	r6,Set_Drive
	bra	Start_TP

SEN_TP:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,2
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	jsr	r6,Display_Sensors
	bra	Start_TP

LED_TP:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,3
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	jsr	r6,Set_LEDs
	bra	Start_TP

DUMP_TP:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,4
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	jsr	r6,Dump_Ram
	bra	Start_TP


End_TP:
	
	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0		

	
	jsr	r6, r6

//=======================================================
//	Display_Sensors
//	This routine is used by the test program to
//	display the status of all offensive and
//	defensive sensors.

Display_Sensors:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r6, sp, 2
	add	sp, sp, 3

Start_DS:
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_DS0
	jsr	r6, XPD_EchoString
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	

	
	mov	r1, STRING_SN
	jsr	r6, XPD_EchoString
	mov	r0,20
Loop_DS:
	ld	r1, SNdata
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
		
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_AN0
	jsr	r6, XPD_EchoString
	ld	r1, IRdata0
	jsr	r6, XPD_EchoUnsignedDecNLZ	
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_AN1
	jsr	r6, XPD_EchoString
	ld	r1, IRdata1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
		
	mov	r1, STRING_AN2
	jsr	r6, XPD_EchoString
	ld	r1, CSdata0
	jsr	r6, XPD_EchoUnsignedDecNLZ	
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_AN3
	jsr	r6, XPD_EchoString
	ld	r1, CSdata1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString
	
	mov	r1, STRING_BP0
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	
	
	mov	r1, STRING_BP1
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-1
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_BP2
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-2
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_BP3
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-3
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_LD0
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-4
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString	
	
	mov	r1, STRING_LD1
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-5
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_LD2
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-6
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_LD3
	jsr	r6, XPD_EchoString
	ld	r1, DEFdata
	rol	r1,r1,-7
	and	r1,r1,1
	jsr	r6, XPD_EchoUnsignedDecNLZ
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1, STRING_DS1
	jsr	r6, XPD_EchoString
	mov	r1, MSG_NEWLINE
	jsr	r6, XPD_EchoString

	mov	r1,0
	jsr	r6, XPD_ReadByte


	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1
	ld	r1, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Set_LEDs
//	This routine is used by the test program to
//	set the LEDs according to the user's input.

Set_LEDs:
	// Store registers on stack
	st	r1, sp, 0
	st	r6, sp, 1
	add	sp, sp, 2
	
Start_SL:

	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_LED
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,0					
	jsr	r6, XPD_ReadByte

	add	r1,r1,-560
	bc	ZC,Skip_SL0
	
	mov	r1,0b0001
	st	r1,LEDdata
	bra	End_SL
Skip_SL0:
	add	r1,r1,-561
	bc	ZC,Skip_SL1	

	mov	r1,0b0010
	st	r1,LEDdata
	bra	End_SL

Skip_SL1:
	add	r1,r1,-562
	bc	ZC,Skip_SL2	

	mov	r1,0b0100
	st	r1,LEDdata
	bra	End_SL
	
Skip_SL2:
	add	r1,r1,-563
	bc	ZC,Skip_SL3	

	mov	r1,0b1000
	st	r1,LEDdata
	bra	End_SL
	
Skip_SL3:
	mov	r1,0b0000
	st	r1,LEDdata

End_SL:
	
	//Restore registers
	sub	sp, sp, 2
	ld	r6, sp, 1
	ld	r1, sp, 0		

	
	jsr	r6, r6

//=======================================================
//	Dump_Ram
//	This routine is used by the test program to
//	dump a ram register to the terminal.

Dump_Ram:
	// Store registers on stack
	st	r1, sp, 0
	st	r6, sp, 1
	add	sp, sp, 2

	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_RAM0
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
Start_RD:

	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_RAM1
	jsr	r6,XPD_EchoString
	jsr	r6,XPD_ReadByte
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r2,r1
	bc	ZS,Loop_RD1
	mov	r0,2
		
Loop_RD0:
	jsr	r6,XPD_ReadByte
	add	r3,r1,-520
	bc	ZS,Start_RD
	add	r3,r1,-525
	bc	ZS,Loop_RD1
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r3,10
	mov	r4,0

Multi_RD0:
	add	r4,r2,r4	
	add	r3,r3,-1
	bc	ZC,Multi_RD0
	
	add	r2,r1,r4
	add	r0,r0,-1
	bc	ZC,Loop_RD0
	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r0,1
	st	r0,SST_EN
Loop_RD1:

	mov	r0, 40000
Loop_RD2:
	sub	r0, r0, 1
	bc	ZC, Loop_RD2

	mov	r0,PWMdata0
	add	r0,r0,r2
	ld	r1,r0,0
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
		
	ld	r0,Check_data
	bra	Loop_RD1

Skip_RD0:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_RAM2
	jsr	r6,XPD_EchoString

	jsr	r6,XPD_ReadByte
	mov	r2,r1
	add	r0,r1,-633
	bc	ZC,Skip_RD1
	mov	r1,STRING_SD24
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	Start_RD

Skip_RD1:	
	add	r0,r1,-622
	bc	ZC,Skip_RD0
	mov	r1,STRING_SD25
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString	
	
End_RD:
	
	//Restore registers
	sub	sp, sp, 2
	ld	r6, sp, 1
	ld	r1, sp, 0		

	
	jsr	r6, r6

//=======================================================
//	Set_Drive
//	This routine used to configure the Drive routine.

Set_Drive:

	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r3, sp, 3	
	st	r4, sp, 4
	st	r5, sp, 5	
	st	r6, sp, 6
	add	sp, sp, 7
	
Start_SD:
	mov	r0,0
	st	r0,DRIVEcfg0
	st	r0,DRIVEcfg1
	st	r0,DRIVEdata
	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_SD0
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString	

	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD1
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD2
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD3
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD4
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

Loop_SD0:
	mov	r1,0
	jsr	r6, XPD_ReadByte

	add	r0,r1,-561
	bc	ZS,Skip_SD0

	add	r0,r1,-562
	bc	ZS,Skip_SD0

	add	r0,r1,-563
	bc	ZS,Skip_SD0

	add	r0,r1,-564
	bc	ZC,Loop_SD0
	
Skip_SD0:
	add	r5,r1,-560
	
Skip_SD1:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_SD5
	jsr	r6,XPD_EchoString
	jsr	r6,XPD_ReadByte
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r2,r1
	bc	ZS,Skip_SD2
	mov	r0,3
		
Loop_SD1:
	jsr	r6,XPD_ReadByte
	add	r3,r1,-520
	bc	ZS,Skip_SD1
	add	r3,r1,-525
	bc	ZS,Skip_SD2
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r3,10
	mov	r4,0

Multi_SD0:
	add	r4,r2,r4	
	add	r3,r3,-1
	bc	ZC,Multi_SD0
	add	r2,r1,r4
	add	r0,r0,-1
	bc	ZS,Skip_SD2
	bra	Loop_SD1

Skip_SD2:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString	
	and	r1,r2,0x0FFF
	st	r2,SENcfg0
	
	mov	r1,0
	st	r1,SENcfg1
	st	r1,SENcfg2
		
	mov	r1,STRING_SD6
	jsr	r6,XPD_EchoString
	jsr	r6,XPD_ReadByte
	and	r1,r1,7
	jsr	r6,XPD_EchoUnsignedDecNLZ
	rol	r3,r1,13
	st	r3,DRIVEcfg1

Skip_SD3:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_SD7
	jsr	r6,XPD_EchoString
	jsr	r6,XPD_ReadByte
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r2,r1
	bc	ZS,Skip_SD4
	mov	r0,2
		
Loop_SD2:
	jsr	r6,XPD_ReadByte
	add	r3,r1,-520
	bc	ZS,Skip_SD3
	add	r3,r1,-525
	bc	ZS,Skip_SD4
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r3,10
	mov	r4,0

Multi_SD1:
	add	r4,r2,r4	
	add	r3,r3,-1
	bc	ZC,Multi_SD1
	add	r2,r1,r4
	add	r0,r0,-1
	bc	ZS,Skip_SD4
	bra	Loop_SD2

Skip_SD4:
	and	r1,r2,0x03FF
	ld	r2,DRIVEcfg1
	and	r2,r2,0xFC00
	add	r2,r2,r1
	st	r2,DRIVEcfg1

Skip_SD5:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD8
	jsr	r6,XPD_EchoString
	jsr	r6,XPD_ReadByte
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r2,r1
	bc	ZS,Skip_SD6
	mov	r0,2	

Loop_SD3:
	jsr	r6,XPD_ReadByte
	add	r3,r1,-520
	bc	ZS,Skip_SD5
	add	r3,r1,-525
	bc	ZS,Skip_SD6
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r3,10
	mov	r4,0

Multi_SD2:
	add	r4,r2,r4	
	add	r3,r3,-1
	bc	ZC,Multi_SD2
	add	r2,r1,r4
	add	r0,r0,-1
	bc	ZS,Skip_SD6
	bra	Loop_SD3

Skip_SD6:
	and	r2,r2,0x00FF
	rol	r2,r2,8
	ld	r1,DRIVEcfg0
	and	r1,r1,0x00FF
	add	r2,r2,r1
	st	r2,DRIVEcfg0

Skip_SD7:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_SD9
	jsr	r6,XPD_EchoString
	jsr	r6,XPD_ReadByte
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r2,r1
	bc	ZS,Skip_SD8
	mov	r0,2
	
Loop_SD4:
	jsr	r6,XPD_ReadByte
	add	r3,r1,-520
	bc	ZS,Skip_SD7
	add	r3,r1,-525
	bc	ZS,Skip_SD8
	and	r1,r1,0x000F
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r3,10
	mov	r4,0
Multi_SD3:
	add	r4,r2,r4	
	add	r3,r3,-1
	bc	ZC,Multi_SD3
	add	r2,r1,r4
	add	r0,r0,-1
	bc	ZS,Skip_SD8
	bra	Loop_SD4

Skip_SD8:	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	and	r2,r2,0x00FF
	ld	r1,DRIVEcfg0
	and	r1,r1,0xFF00
	add	r1,r1,r2
	ld	r1,DRIVEcfg0
	add	r3,r2,r1
	
Skip_SD9:
	st	r3,DRIVEcfg0

	add	r0,r5,-4
	bc	ZS,Skip_SD17
	
	add	r0,r5,-3
	bc	ZS,Skip_SD10

	add	r0,r5,-2
	bc	ZS,Skip_SD11

	add	r0,r5,-1
	bc	ZC,Start_SD

	jsr	r6,Sim_Sensor_Encoder
	bra	Skip_SD12

Skip_SD10:
	jsr	r6,Sim_Encoder
	bra	Skip_SD12

Skip_SD11:
	jsr	r6,Sim_Sensor
	bra	Skip_SD12	
	
Skip_SD17:	
	mov	r0,1
	st	r0,DRIVE_EN
Loop_SD5:
	ld	r0,DRIVE_EN
	bc	ZC,Loop_SD5

Skip_SD12:

	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong
	jsr	r6,DelayReallyLong

	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD10
	jsr	r6,XPD_EchoString
	ld	r1,DRIVEdata
	and	r1,r1,0x0FFF
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_SD11
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
	mov	r1,STRING_SD12
	jsr	r6,XPD_EchoString	
	ld	r1,DRIVEdata
	and	r1,r1,0x7FFF
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,STRING_SD13
	jsr	r6,XPD_EchoString	
	ld	r1,DRIVEdata
	jsr	r6,XPD_EchoHex	
	mov	r1,STRING_SD14
	jsr	r6,XPD_EchoString	
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD15
	jsr	r6,XPD_EchoString
	ld	r1,SENcfg0
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD16
	jsr	r6,XPD_EchoString
	ld	r1,SENdata0
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD17
	jsr	r6,XPD_EchoString
	ld	r1,ECdata0
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD18
	jsr	r6,XPD_EchoString
	ld	r1,ECdata1
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD30
	jsr	r6,XPD_EchoString
	ld	r1,ECdata0c
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD31
	jsr	r6,XPD_EchoString
	ld	r1,ECdata1c
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD28
	jsr	r6,XPD_EchoString
	ld	r1,ECtime0b
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD29
	jsr	r6,XPD_EchoString
	ld	r1,ECtime1b
	jsr	r6,XPD_EchoHex
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString


	mov	r1,STRING_SD19
	jsr	r6,XPD_EchoString
	ld	r1,PWMdata0a
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD20
	jsr	r6,XPD_EchoString
	ld	r1,PWMdata1a
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD21
	jsr	r6,XPD_EchoString
	ld	r1,Dir0
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SD22
	jsr	r6,XPD_EchoString
	ld	r1,Dir1
	jsr	r6,XPD_EchoUnsignedDecNLZ
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

Skip_SD13:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,STRING_SD23
	jsr	r6,XPD_EchoString

	jsr	r6,XPD_ReadByte
	mov	r2,r1
	add	r0,r1,-633
	bc	ZC,Skip_SD14
	mov	r1,STRING_SD24
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	Skip_SD15

Skip_SD14:	
	add	r0,r1,-622
	bc	ZC,Skip_SD13
	mov	r1,STRING_SD25
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	End_SD	

Skip_SD15:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	mov	r1,STRING_SD26
	jsr	r6,XPD_EchoString
	
	jsr	r6,XPD_ReadByte
	add	r0,r1,-633
	bc	ZC,Skip_SD16
	mov	r1,STRING_SD24
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	Start_SD
	
Skip_SD16:
	add	r0,r1,-622
	bc	ZC,Skip_SD15
	mov	r1,STRING_SD25
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	Skip_SD9

End_SD:

	//Restore registers
	sub	sp, sp, 7
	ld	r6, sp, 6
	ld	r5, sp, 5		
	ld	r4, sp, 4	
	ld	r3, sp, 3		
	ld	r2, sp, 2		
	ld	r1, sp, 1			
	ld	r0, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Sim_Encoder
//	This routine is used by the test program to
//	simulate only the encoders.

Sim_Encoder:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r6, sp, 2
	add	sp, sp, 3

Start_SE:
	
	mov	r0,1
	st	r0,DRIVE_EN
	
	mov	r0,0
Loop_SE0:
	add	r0,r0,1
	st	r0,ECdata0
	st	r0,ECdata1
	mov	r1,0xFFFF
	jsr	r6,Delay
	ld	r1,DRIVE_EN
	bc	ZC,Loop_SE0

	jsr	r6,Sensors_Display

	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6
	
	
//=======================================================
//	Sim_Sensor
//	This routine is used by the test program to
//	simulate only the sensors.

Sim_Sensor:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r6, sp, 3
	add	sp, sp, 4

Start_SS:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r0,1
	st	r0,SST_EN
	
	mov	r1,STRING_SDP0
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r0,1
	st	r0,DRIVE_EN

Loop_SS0:
	ld	r0,DRIVE_EN
	bc	ZC,Loop_SS0
	
	mov	r0,0
	st	r0,SST_EN
	
	jsr	r6,Sensors_Display
	
	mov	r1,STRING_SDP1
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString	
	
Loop_SS1:
	ld	r0,Check_data
	add	r0,r0,1
	bc	ZC,Loop_SS1
	
	//Restore registers
	sub	sp, sp, 4
	ld	r6, sp, 3
	ld	r2, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Sim_Sensor_Encoder
//	This routine is used by the test program to
//	simulate the sensors and the encoders.

Sim_Sensor_Encoder:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r6, sp, 3
	add	sp, sp, 4

Start_SSE:
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

	mov	r1,STRING_SDP0
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString


	mov	r0,1
	st	r0,SST_EN

	mov	r0,1
	st	r0,DRIVE_EN

	mov	r2,0
Loop_SSE0:
	add	r2,r2,1
	st	r2,ECdata0
	st	r2,ECdata1
	mov	r1,20000
	jsr	r6,Delay
	ld	r0,DRIVE_EN
	bc	ZC,Loop_SSE0

	jsr	r6,Sensors_Display

	mov	r0,0
	st	r0,SST_EN
	
Skip_SSE:
	mov	r1,STRING_SDP1
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString	

Loop_SSE1:
	ld	r0,Check_data
	add	r0,r0,1
	bc	ZC,Loop_SSE1

	//Restore registers
	sub	sp, sp, 4
	ld	r6, sp, 3
	ld	r2, sp, 2
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Sensor_Set
//	This routine is used by the sensor
//	simulator routines to monitor the
//	keyboard for entries.

Sensor_Set:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r6, sp, 2
	add	sp, sp, 3

	mov	r0,0
	st	r0,SST_EN
	
Start_SST:
	ld	r0,SST_EN
	bc	ZS,Start_SST

Loop_SST0:
	mov	r1,0
	jsr	r6, XPD_ReadByte	

	add	r0,r1,-525
	bc	ZS,ENTER_SST

	ld	r0,SST_EN
	bc	ZS,Loop_SST0

	add	r0,r1,-561
	bc	ZS,ONE_SST

	add	r0,r1,-562
	bc	ZS,TWO_SST

	add	r0,r1,-563
	bc	ZS,THREE_SST

	add	r0,r1,-564
	bc	ZS,FOUR_SST

	bra	Start_SST

ENTER_SST:
	mov	r0,0xFFFF
	st	r0,Check_data

	mov	r1, 0xFFFF
Loop_SST:
	sub	r1, r1, 1
	bc	ZC, Loop_SST

	mov	r0,0
	st	r0,Check_data	
	bra	Start_SST

ONE_SST:
	mov	r0,0x0F
	st	r0,DEFdata
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	bra	Start_SST

TWO_SST:
	mov	r0,0xF0
	st	r0,DEFdata
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF	
	bra	Start_SST

THREE_SST:
	mov	r0,0
	st	r0,SNdata
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	bra	Start_SST

FOUR_SST:
	mov	r0,555
	st	r0,IRdata0
	st	r0,IRdata1

	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	mov	r0,0xFFFF
	bra	Start_SST

	//Restore registers
	sub	sp, sp, 3
	ld	r6, sp, 2
	ld	r1, sp, 1		
	ld	r0, sp, 0
	
	jsr	r6, r6

//=======================================================
//	Sensors_Display
//	This routine is used to display which sensors
//	have caused the drive routine to end.
// 
//-------------------------------------------------------
//	Input Params:
//			SENdata    -> 0=Don't Check - Returns 0
//					  bit 0 = Set to check if the sensor is set, clear to check if sensor is cleared
//					  bit 1 = Sonar
//					  bit 2 = IR0
//					  bit 3 = IR1
//					  bit 4-7 = Bumpers
//					  bit 8-11 = Line Detectors

Sensors_Display:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r3, sp, 3
	st	r6, sp, 4
	add	sp, sp, 5

Start_SDP:

	ld	r2,SENdata0
	and	r0,r2,0x0FFE
	bc	ZS,ZERO_SDP
	
SNcheck_SDP:
	and	r0,r2,0x0002
	bc	ZS,IR0check_SDP
	mov	r1,STRING_SDP4
	jsr	r6,XPD_EchoString
		
	and	r0,r2,1	
	bc	ZS,SNcl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString	
	bra	IR0check_SDP
	
SNcl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

IR0check_SDP:
	and	r0,r2,0x0004
	bc	ZS,IR1check_SDP
	mov	r1,STRING_SDP5
	jsr	r6,XPD_EchoString
	mov	r1,0
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,IR0cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	IR1check_SDP
	
IR0cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

IR1check_SDP:
	and	r0,r2,0x0008
	bc	ZS,SW0check_SDP
	mov	r1,STRING_SDP5
	jsr	r6,XPD_EchoString
	mov	r1,1
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
			
	and	r0,r2,1
	bc	ZS,IR1cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	SW0check_SDP
	
IR1cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

SW0check_SDP:
	and	r0,r2,0x0010
	bc	ZS,SW1check_SDP
	mov	r1,STRING_SDP6
	jsr	r6,XPD_EchoString
	mov	r1,1
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
		
	and	r0,r2,1
	bc	ZS,SW0cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	SW1check_SDP

SW0cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

SW1check_SDP:
	and	r0,r2,0x0020
	bc	ZS,SW2check_SDP
	mov	r1,STRING_SDP6
	jsr	r6,XPD_EchoString
	mov	r1,2
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,SW1cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	SW2check_SDP

SW1cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

SW2check_SDP:
	and	r0,r2,0x0040
	bc	ZS,SW3check_SDP
	mov	r1,STRING_SDP6
	jsr	r6,XPD_EchoString
	mov	r1,3
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,SW2cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	SW3check_SDP

SW2cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

SW3check_SDP:
	and	r0,r2,0x0080
	bc	ZS,LD0check_SDP
	mov	r1,STRING_SDP6
	jsr	r6,XPD_EchoString
	mov	r1,4
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,SW3cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	LD0check_SDP

SW3cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

LD0check_SDP:
	and	r0,r2,0x0100
	bc	ZS,LD1check_SDP
	mov	r1,STRING_SDP7
	jsr	r6,XPD_EchoString
	mov	r1,1
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,LD0cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	LD1check_SDP

LD0cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

LD1check_SDP:
	and	r0,r2,0x0200
	bc	ZS,LD2check_SDP
	mov	r1,STRING_SDP7
	jsr	r6,XPD_EchoString
	mov	r1,2
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,LD1cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	LD2check_SDP

LD1cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

LD2check_SDP:
	and	r0,r2,0x0400
	bc	ZS,LD3check_SDP
	mov	r1,STRING_SDP7
	jsr	r6,XPD_EchoString
	mov	r1,3
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,LD2cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	LD3check_SDP

LD2cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString

LD3check_SDP:
	and	r0,r2,0x0800
	bc	ZS,End_SDP
	mov	r1,STRING_SDP7
	jsr	r6,XPD_EchoString
	mov	r1,4
	jsr	r6,XPD_EchoUnsignedDecNLZ	
	mov	r1,STRING_SDP8
	jsr	r6,XPD_EchoString
	
	and	r0,r2,1
	bc	ZS,LD3cl_SDP

	mov	r1,STRING_SDP2
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	End_SDP

LD3cl_SDP:
	mov	r1,STRING_SDP3
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	End_SDP

ZERO_SDP:
	and	r0,r2,1
	bc	ZS,ZEROcl_SDP

	mov	r1,STRING_SDP9
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	bra	End_SDP

ZEROcl_SDP:
	mov	r1,STRING_SDP10
	jsr	r6,XPD_EchoString
	mov	r1,MSG_NEWLINE
	jsr	r6,XPD_EchoString
	
End_SDP:

	//Restore registers
	sub	sp, sp, 5
	ld	r6, sp, 4
	ld	r3, sp, 3
	ld	r2, sp, 2		
	ld	r1, sp, 1
	ld	r0, sp, 0
	
	jsr	r6, r6