//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  TrackingProgram.asm
//**       Project:  Quick Start Project
//**       Created:  25 Jun 2002 by Ryan Northcott
//**       Revised:  08 Sep 2006 by Dan Beutel
//**
//**   Description:  This thread is an artificial thread that runs as a subroutin in Thread4.
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************

Program:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1	
	st	r6, sp, 2
	add	sp, sp, 3

Hunt:
	jsr	r6,Hunt_P1
	
	//Check Defensive sensors
	ld	r0,SENdata0
	and	r0,r0,0x0FF0
	bc	ZC,Def
	bra	Hunt
	
Def:
	jsr	r6,Defense_P1
	bra	Hunt
			
	//Restore registers
	sub	sp, sp, 2
	ld	r6, sp, 1		
	ld	r0, sp, 0
	
	jsr	r6, r6

Hunt_P1:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r3, sp, 3	
	st	r4, sp, 4
	st	r5, sp, 5	
	st	r6, sp, 6
	add	sp, sp, 7
	
	//spin left search
	mov	r0,0
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1		
	
	mov	r0,20
	st	r0,PWMdata0
	st	r0,PWMdata1
	//Continue spinning until a sensor goes off
Search:
	mov	r0,0x0FFF
	st	r0,SENcfg1

	mov	r1,500
	jsr	r6,Delay

	//Exit if defensive sensors are activated
	ld	r1,SENdata1
	and 	r2,r1,0x0FF0
	bc 	ZC,Exit_Search

	//Branch if one of the offensive sensors are activated
	and 	r2,r1,0x000E
	bc	ZC,Found		
	
	mov	r0,20
	st	r0,PWMdata0
	st	r0,PWMdata1

	//Continue search until a sensor goes off		
	bra	Search

	//Determine which offensive sensors has been activated
Found:
	and	r3,r2,0x0008		//check IR1 set off
	bc	ZC, Target_Right
	and	r3,r2,0x0004		//check IR0 set off
	bc	ZC, Target_Left

	//If only the sonar is activated then we are locked on, full speed ahead!	
Locked:
	ld	r1,SENdata1
	and 	r2,r1,0x0FF0		//LD AND BUMPERS
	bc 	ZC,Exit_Search
	
	and 	r2,r1,0x000E
	sub	r2,r2,0x0002
	bc	ZC, Search
	
	mov	r0,1
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1	
	
Skip_A:
	mov	r0,30
	
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Locked
	
Target_Left:
	mov	r0,0
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1	
	
	mov	r0,20
	st	r0,PWMdata0
	st	r0,PWMdata1
	
	bra Search

Target_Right:
	mov	r0,1
	st	r0,Dir0
	mov	r0,0
	st	r0,Dir1	
	
	mov	r0,20
	st	r0,PWMdata0
	st	r0,PWMdata1
	
	bra Search
	
Exit_Search:

	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
//Restore registers
	sub	sp, sp, 7
	ld	r6, sp, 6
	ld	r5, sp, 5		
	ld	r4, sp, 4	
	ld	r3, sp, 3		
	ld	r2, sp, 2		
	ld	r1, sp, 1			
	ld	r0, sp, 0
	
	jsr	r6, r6

Attack_P1:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r3, sp, 3	
	st	r4, sp, 4
	st	r5, sp, 5	
	st	r6, sp, 6
	add	sp, sp, 7

		
	//Restore registers
	sub	sp, sp, 7
	ld	r6, sp, 6
	ld	r5, sp, 5		
	ld	r4, sp, 4	
	ld	r3, sp, 3		
	ld	r2, sp, 2		
	ld	r1, sp, 1			
	ld	r0, sp, 0

Defense_P1:
	// Store registers on stack
	st	r0, sp, 0
	st	r1, sp, 1
	st	r2, sp, 2
	st	r3, sp, 3	
	st	r4, sp, 4
	st	r5, sp, 5	
	st	r6, sp, 6
	add	sp, sp, 7

Start_DF:
	mov	r0,0x0FF1
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	
	and	r1,r0,0x0300
	sub	r1,r1,0x0300		//line detector check	
	bc	ZS,LD12
	
	and	r1,r0,0x0500
	sub	r1,r1,0x0500
	bc	ZS,LD13
	
	and	r1,r0,0x0A00
	sub	r1,r1,0x0A00
	bc	ZS,LD24
	
	and	r1,r0,0x0C00
	sub	r1,r1,0x0C00
	bc	ZS,LD34
	
	and	r1,r0,0x0100
	bc	ZC,LD1
	
	and	r1,r0,0x0200
	bc	ZC,LD2
	
	and	r1,r0,0x0400
	bc	ZC,LD3
	
	and	r1,r0,0x0800
	bc	ZC,LD4
	
	and	r1,r0,0x0010
	bc	ZC,BS1
	
	and	r1,r0,0x0020
	bc	ZC,BS2
	
	and	r1,r0,0x0040
	bc	ZC,BS3
	
	and	r1,r0,0x0080
	bc	ZC,BS4
	bra	End_DF


LD12:		//Forward 10cm ->hunt

	mov	r0,1
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,100
	st	r0,PWMdata0	
	mov	r0,100
	st	r0,PWMdata1
	
Loop_LD12b:	
	mov	r0,0x0300
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0300
	sub	r0,r0,0x0300
	bc	ZC,Loop_LD12b
	
	mov	r2,100	//Time constant
Loop_LD12:	//Check LD3 & LD4
	mov	r0,0x0C01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0C00
	bc	ZC,Stop_LD12
	sub	r2,r2,1
	bc	NC,Loop_LD12
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD12:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF


LD13:	//Pivot 90 left, Forward 10cm ->hunt
	mov	r0,0
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,0
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1

Loop_LD13b:	
	mov	r0,0x0500
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0500
	sub	r0,r0,0x0500
	bc	ZC,Loop_LD13b

	mov	r2,45	//Time constant
Loop_LD13:	//Check LD2 & LD4
	mov	r0,0x0A01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0A00
	bc	ZC,Stop_LD13
	sub	r2,r2,1
	bc	NC,Loop_LD13
	
	mov	r0,1
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,45		//Time constant	
Loop_LD13a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD13
	sub	r2,r2,1
	bc	NC,Loop_LD13a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD13:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF

LD24:		//Pivot 90 right, Forward 10cm ->hunt
	mov	r0,1
	st	r0,Dir0
	mov	r0,0
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,0
	st	r0,PWMdata1

Loop_LD24b:	
	mov	r0,0x0A00
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0A00
	sub	r0,r0,0x0A00
	bc	ZC,Loop_LD24b
	
	mov	r2,45	//Time constant
Loop_LD24:	//Check LD1 & LD3
	mov	r0,0x0501
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0500
	bc	ZC,Stop_LD24
	sub	r2,r2,1
	bc	NC,Loop_LD24
	
	mov	r0,1
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,45		//Time constant	
Loop_LD24a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD24
	sub	r2,r2,1
	bc	NC,Loop_LD24a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD24:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF

LD34:	//Back 10cm, Spin 180 ->hunt
	mov	r0,0
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100
	st	r0,PWMdata0	
	mov	r0,100
	st	r0,PWMdata1

Loop_LD34b:	
	mov	r0,0x0C00
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0C00
	sub	r0,r0,0x0C00
	bc	ZC,Loop_LD34b
	
	mov	r2,100	//Time constant
Loop_LD34:	//Check LD1 & LD2
	mov	r0,0x0301
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0300
	bc	ZC,Stop_LD34
	sub	r2,r2,1
	bc	NC,Loop_LD34
	
	mov	r0,0
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,45		//Time constant	
Loop_LD34a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD34
	sub	r2,r2,1
	bc	NC,Loop_LD34a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD34:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF

LD1:	//Forward 10cm, Spin 45 left ->hunt
	mov	r0,1
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100
	st	r0,PWMdata0	
	mov	r0,100
	st	r0,PWMdata1

Loop_LD1b:	
	mov	r0,0x0100
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0100
	sub	r0,r0,0x0100
	bc	ZC,Loop_LD1b
	
	mov	r2,100	//Time constant
Loop_LD1:	//Check LD2, LD3 & LD4
	mov	r0,0x0E01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0E00
	bc	ZC,Stop_LD1
	sub	r2,r2,1
	bc	NC,Loop_LD1
	
	mov	r0,0
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,15		//Time constant	
Loop_LD1a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD1
	sub	r2,r2,1
	bc	NC,Loop_LD1a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD1:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF


LD2:	//Forward 10cm, Spin 45 right ->hunt
	mov	r0,1
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100
	st	r0,PWMdata0	
	mov	r0,100
	st	r0,PWMdata1

Loop_LD2b:	
	mov	r0,0x0200
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0200
	sub	r0,r0,0x0200
	bc	ZC,Loop_LD2b
	
	mov	r2,100	//Time constant
Loop_LD2:	//Check LD1, LD3 & LD4
	mov	r0,0x0D01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0D00
	bc	ZC,Stop_LD2
	sub	r2,r2,1
	bc	NC,Loop_LD2
	
	mov	r0,1
	st	r0,Dir0
	mov	r0,0
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,15		//Time constant	
Loop_LD2a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD2
	sub	r2,r2,1
	bc	NC,Loop_LD2a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD2:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF


LD3:	//Back 10cm, Spin 140 left ->hunt
	mov	r0,0
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100
	st	r0,PWMdata0	
	mov	r0,100
	st	r0,PWMdata1

Loop_LD3b:	
	mov	r0,0x0400
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0400
	sub	r0,r0,0x0400
	bc	ZC,Loop_LD3b
	
	mov	r2,100	//Time constant
Loop_LD3:	//Check LD1, LD2 & LD4
	mov	r0,0x0B01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0B00
	bc	ZC,Stop_LD3
	sub	r2,r2,1
	bc	NC,Loop_LD3
	
	mov	r0,0
	st	r0,Dir0
	mov	r0,1
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,40		//Time constant	
Loop_LD3a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD3
	sub	r2,r2,1
	bc	NC,Loop_LD3a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD3:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF	

LD4:	//Back 10cm, Spin 140 right ->hunt
	mov	r0,0
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100
	st	r0,PWMdata0	
	mov	r0,100
	st	r0,PWMdata1

Loop_LD4b:	
	mov	r0,0x0800
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0800
	sub	r0,r0,0x0800
	bc	ZC,Loop_LD4b
	
	mov	r2,100	//Time constant
Loop_LD4:	//Check LD1, LD2 & LD3
	mov	r0,0x0701
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0700
	bc	ZC,Stop_LD4
	sub	r2,r2,1
	bc	NC,Loop_LD4
	
	mov	r0,1
	st	r0,Dir0
	mov	r0,0
	st	r0,Dir1
	
	mov	r0,50
	st	r0,PWMdata0	
	mov	r0,50
	st	r0,PWMdata1
	
	mov	r2,40		//Time constant	
Loop_LD4a:	//Check LD1, LD2, LD3 or LD4
	mov	r0,0x0F01
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r0,r0,0x0F00
	bc	ZC,Stop_LD4
	sub	r2,r2,1
	bc	NC,Loop_LD4a	
	
		//Stop and branch to Hunt
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF
	
Stop_LD4:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF

BS1:				//when bumper 1 is set off, go forward 100%
	mov	r0,1		//initialize motors for forward direction
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100	//motors to 100%
	st	r0,PWMdata0
	st	r0,PWMdata1
	
	mov	r0,0x0C11	//check that bumper switch 1 and line detector 43, are high
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r1,r0,0x0C00	//check line detectors
	bc	ZC,Stop_BS1		//if LD34 are over white, branch out of BS1 subroutine
	and	r0,r0,0x0010	//check to see if BS1 is being pressed
	bc	ZC,BS1		//if bumper is being pressed again, keep looping
	
	//Stop and branch to Hunt
	mov	r0,0			//stop the motors	
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF		//branch to defense mode
	
Stop_BS1:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF		//branch to defense mode
	
BS2:					//Checks status of right bumper switch
	mov	r0,1		//initialize motors for backwards direction
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,15			//turns
	st	r0,PWMdata0
	mov 	r0,100		//turns
	st	r0,PWMdata1
	
	mov	r0,0x0521		//check that bumper switch 2 and line detector 31, are high
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r1,r0,0x0500	//check line 31
	bc	ZC,Go_BS2		//if LD31 are over white, branch out of BS2 subroutine
	and	r0,r0,0x0020	//check to see if BS2 is being pressed
	bc	ZC,BS2		//if bumper is being pressed again, keep looping
	
	//Stop and branch to Hunt
	mov	r0,0			//stop the motors	
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF		//branch to hunt mode
	
Go_BS2:				//Keeping going to get out of the push
	mov	r0,100
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF
	
	
BS3:					//Checks status of left bumper switch
	mov	r0,1			//initialize motors for backwards direction
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100		//turns
	st	r0,PWMdata0
	mov 	r0,15			//turns
	st	r0,PWMdata1
	
	mov	r0,0x0A41		//check that bumper switch 3 and line detector 42, are high
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r1,r0,0x0A00	//check line 42
	bc	ZC,Go_BS3		//if LD42 are over white, branch out of BS3 subroutine
	and	r0,r0,0x0040	//check to see if BS3 is being pressed
	bc	ZC,BS3		//if bumper is being pressed again, keep looping
	
	//Stop and branch to Hunt
	mov	r0,0			//stop the motors	
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF		//branch to hunt mode
	
Go_BS3:				//Keeping going to get out of the push
	mov	r0,100
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF
	
BS4:					//Checks status of back bumper switch
	mov	r0,0		//initialize motors for backwards direction
	st	r0,Dir0
	st	r0,Dir1
	
	mov	r0,100	//motors to 100%
	st	r0,PWMdata0
	st	r0,PWMdata1
	
	mov	r0,0x0381	//check that bumper switch 4 and line detector 21, are high
	st	r0,SENcfg0
	mov	r1,5000
	jsr	r6,Delay
	ld	r0,SENdata0
	and	r1,r0,0x0300	//check line 21
	bc	ZC,Stop_BS4		//if LD21 are over white, branch out of BS2 subroutine
	and	r0,r0,0x0080	//check to see if BS2 is being pressed
	bc	ZC,BS4		//if bumper is being pressed again, keep looping
	
	//Stop and branch to Hunt
	mov	r0,0			//stop the motors	
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	End_DF		//branch to defense mode
	
Stop_BS4:	//Stop and branch to Defend
	mov	r0,0
	st	r0,PWMdata0
	st	r0,PWMdata1
	bra	Start_DF	
		
		

End_DF:
	
	//Restore registers
	sub	sp, sp, 7
	ld	r6, sp, 6
	ld	r5, sp, 5		
	ld	r4, sp, 4	
	ld	r3, sp, 3		
	ld	r2, sp, 2		
	ld	r1, sp, 1			
	ld	r0, sp, 0
	
	jsr	r6, r6

	bra	@	// Prevent this thread from running away if it is accidentally enabled in the main file