//*************************************************************************************************
//************************ (C) 2001 - 2006, Eleven Engineering Incorporated ***********************
//*************************************************************************************************
//**
//**		Tabs:	This file looks best with tab stops set every 6 spaces.
//**
//*************************************************************************************************
//*************************************************************************************************
//**
//**          File:  XPD Debugger Data.asm
//**       Project:  XInc2 Library
//**       Created:  04 Jan 2003 by Ryan Northcott
//**       Revised:  08 Sep 2006 by Dan Beutel
//**
//**   Description:  Data used by the routines in "XPD_Debugger.asm."
//**
//** Compatibility:  Requires XInA v4.4 or higher.
//**
//**    Disclaimer:  You may incorporate this sample source code into your program(s) without
//**                 restriction.  This sample source code has been provided "AS IS" and the
//**                 responsibility for its operation is yours.  You are not permitted to
//**                 redistribute this sample source code as "Eleven sample source code" after
//**                 having made changes.  If you are going to re-distribute the source, we require
//**                 that you make it clear in the source that the code was descended from Eleven
//**                 sample source code, but that you have made changes.
//**
//*************************************************************************************************
//*************************************************************************************************


///////////////////////////////////////////////////////////////////////////
// GENERAL
//
MSG_VERSION:	"XInc2 Debugger Lite (08 Sep 2006 Build)", CR, LF, EOS
MSG_PROMPT:		">", EOS
MSG_USERBREAK:	"User Break",EOS
MSG_BREAKPOINT:	"Breakpoint in Thread(s) ",EOS

///////////////////////////////////////////////////////////////////////////
// COMMAND SUMMARY
//
MSG_COMMANDS:
	"Go:                          g (<Enter> to stop)",CR,LF
	"Step:                        s <# of instructions> (no parameter defaults to 1)",CR,LF
	"Display Block:               db <address> <# of words> <words per line> (last 2 parameters default to 24, 8)",CR,LF
	"Enable Threads:              e <active thread byte>",CR,LF
	"Help:                        ?",CR,LF
	"Output User Data:            o (Add code to output your data here)",CR,LF
	"Write Memory:                wm <address> <word>",CR,LF
	"Write PC:                    wp <thread #> <word>",CR,LF
	"Write CC:                    wc <thread #> <0bNZVC>",CR,LF
	"Write Reg:                   wr <thread #> <register #> <word>",CR,LF
	EOS

///////////////////////////////////////////////////////////////////////////
// COMMAND RESPONSES
//
ERR_CMD:		"Invalid command",EOS
ERR_BYTES:		"Invalid number of bytes",EOS
ERR_THREAD:		"Invalid thread",EOS
ERR_REG:		"Invalid register",EOS
ERR_ADDRESS:	"Invalid address",EOS
ERR_WORD:		"Invalid word value",EOS
ERR_THREADBYTE:	"Invalid active thread byte",EOS

///////////////////////////////////////////////////////////////////////////
// THREAD TABLE
//
MSG_THREAD:		"Thread: ",EOS
MSG_PC:		"PC ",EOS
MSG_CC:		"CC ",EOS
MSG_R:		"R",EOS
MSG_N:		"N",EOS
MSG_Z:		"Z",EOS
MSG_V:		"V",EOS
MSG_C:		"C",EOS
MSG_DASH:		"-",EOS
MSG_COLON:		": ",EOS
MSG_REG:		"Regs: ",EOS
MSG_DONE:		"Done",EOS
MSG_TAB_HEADER:	"   Thread7 Thread6 Thread5 Thread4 Thread3 Thread2 Thread1 Thread0",CR,LF,EOS
MSG_DEBUG:		"Debug",EOS
MSG_ON:		"On",EOS
MSG_OFF:		"Off",EOS
MSG_BKPT:		"Bkpt",EOS

///////////////////////////////////////////////////////////////////////////
// MEMORY VARIABLES
//
EnabledThreads:			@ = @ + 1
SCU_PNTR:				@ = @ + 1
THREAD_BYTE: ADDRESS:		@ = @ + 1
WORD_VALUE:				@ = @ + 1
BUFFER:				@ = @ + kDebugBufferSize
NUM_PER_LINE:			@ = @ + 1